// ---------------------------------------------------*- C++ -*--------------
//  Copyright (C) 1990-2007 by ILOG.
//  All Rights Reserved.
//
//  N O T I C E
//
//  THIS MATERIAL IS CONSIDERED A TRADE SECRET BY ILOG.
//  UNAUTHORIZED ACCESS, USE, REPRODUCTION OR DISTRIBUTION IS PROHIBITED.
// --------------------------------------------------------------------------
#ifndef __CONCERT_ilorequestcacheH 
#define __CONCERT_ilorequestcacheH

#if !defined(__CONCERT_iloenvH)
# include <ilconcert/iloenv.h> 
#endif

#if !defined(__CONCERT_ilostringH)
# include <ilconcert/ilostring.h> 
#endif

#if !defined(__CONCERT_ilotuplebufferH)
# include <ilconcert/iltuple/ilotuplebuffer.h> 
#endif

#if !defined(__CONCERT_ilohashH)
# include <ilconcert/ilohash.h> 
#endif

#if !defined(__CONCERT_ilotuplecollectionhashH)
# include <ilconcert/iltuple/ilotuplecollectionhash.h> 
#endif

class IloQueryDataTableHash;
class IloTupleRequest;
class IloTupleRequestI;
class IloTupleSetI;
class IloTupleSet;

class IloIntDataColumnI;
class IloNumDataColumnI;
class IloAnyDataColumnI;

/**
* @group optim.concert.tuple
* @show internal
* <p> IloTupleRequestCacheI </p>
**/
class IloTupleRequestCacheI : public IloEnvObjectI {
protected:
	IloIntArray _empty;
public:
	/** <p> . </p> */
	IloTupleRequestCacheI(IloEnv env);
	virtual ~IloTupleRequestCacheI();
	/** <p> . </p> */
	virtual IloIntArrayI* execute()=0;
	/** <p> . </p> */
	virtual IloBool store(IloIntArrayI* slice)=0;
};

class IloTupleRequestUnaryCacheI : public IloEnvObjectI {
public:
	/** <p> . </p> */
	IloTupleRequestUnaryCacheI(IloEnv env);
	virtual ~IloTupleRequestUnaryCacheI();
	/** <p> . </p> */
	virtual IloInt execute()=0;
	/** <p> . </p> */
	virtual IloBool store(IloInt slice)=0;
};

IloBool IloMultipleIntCompFunction(IloInt** key1, IloInt** key2);
IloInt IloMultipleIntHashFunction(IloInt** key, IloInt size);

/**
* @group optim.concert.tuple
* @show internal
* <p> IloMultipleIntHashTable </p>
**/
class IloMultipleIntHashTable : public IloEnvHashTable<IloInt**, IloIntArrayI*> {
private:
	IloInt _size;
public:
	/** <p> . </p> */
	IloMultipleIntHashTable(IloEnv env, IloInt size); 
	virtual ~IloMultipleIntHashTable();
};


/**
* @group optim.concert.tuple
* @show internal
* <p> IloNaryIntCacheI </p>
**/
class IloNaryIntCacheI : public IloTupleRequestCacheI {
private:
	IloInt _keySize;
	IloInt** _key;
	IloMultipleIntHashTable* _hash;
public:
	/** <p> . </p> */
	IloNaryIntCacheI(IloEnv env,
		IloInt keySize, IloInt** key,
		IloMultipleIntHashTable* h);
	virtual ~IloNaryIntCacheI();
	/** <p> . </p> */
	virtual IloIntArrayI* execute();
	/** <p> . </p> */
	virtual IloBool store(IloIntArrayI* slice);
};


class IloMultipleUnaryIntHashTable : public IloEnvHashTable<IloInt**, IloInt> {
private:
	IloInt _size;
public:
	/** <p> . </p> */
	IloMultipleUnaryIntHashTable(IloEnv env, IloInt size); 
	virtual ~IloMultipleUnaryIntHashTable();
};

class IloNaryIntUnaryCacheI : public IloTupleRequestUnaryCacheI {
private:
	IloInt _keySize;
	IloInt** _key;
	IloMultipleUnaryIntHashTable* _hash;
public:
	/** <p> . </p> */
	IloNaryIntUnaryCacheI(IloEnv env,
		IloInt keySize, IloInt** key,
		IloMultipleUnaryIntHashTable* h);
	virtual ~IloNaryIntUnaryCacheI();
	/** <p> . </p> */
	virtual IloInt execute();
	/** <p> . </p> */
	virtual IloBool store(IloInt slice);
};

IloBool IloMultipleNumCompFunction(IloNum** key1, IloNum** key2);
IloInt IloMultipleNumHashFunction(IloNum** key, IloInt size);

/**
* @group optim.concert.tuple
* @show internal
* <p> IloMultipleNumHashTable </p>
**/
class IloMultipleNumHashTable : public IloEnvHashTable<IloNum**, IloIntArrayI*> {
private:
	IloInt _size;
public:
	/** <p> . </p> */
	IloMultipleNumHashTable(IloEnv env, IloInt size);
	virtual ~IloMultipleNumHashTable();
};

/**
* @group optim.concert.tuple
* @show internal
* <p> IloNaryNumCacheI </p>
**/
class IloNaryNumCacheI : public IloTupleRequestCacheI {
private:
	IloInt _keySize;
	IloNum** _key;
	IloMultipleNumHashTable* _hash;
public:
	/** <p> . </p> */
	IloNaryNumCacheI(IloEnv env, 
		IloInt keySize, IloNum** key,
		IloMultipleNumHashTable* h);
	virtual ~IloNaryNumCacheI();
	/** <p> . </p> */
	virtual IloIntArrayI* execute();
	/** <p> . </p> */
	virtual IloBool store(IloIntArrayI* slice);
};

class IloMultipleUnaryNumHashTable : public IloEnvHashTable<IloNum**, IloInt> {
private:
	IloInt _size;
public:
	/** <p> . </p> */
	IloMultipleUnaryNumHashTable(IloEnv env, IloInt size);
	virtual ~IloMultipleUnaryNumHashTable();
};

class IloNaryNumUnaryCacheI : public IloTupleRequestUnaryCacheI {
private:
	IloInt _keySize;
	IloNum** _key;
	IloMultipleUnaryNumHashTable* _hash;
public:
	/** <p> . </p> */
	IloNaryNumUnaryCacheI(IloEnv env, 
		IloInt keySize, IloNum** key,
		IloMultipleUnaryNumHashTable* h);
	virtual ~IloNaryNumUnaryCacheI();
	virtual IloInt execute();
	virtual IloBool store(IloInt slice);
};

IloBool IloMultipleAnyCompFunction(IloAny** key1, IloAny** key2);
IloInt IloMultipleAnyHashFunction(IloAny** key, IloInt size);

/**
* @group optim.concert.tuple
* @show internal
* <p> IloMultipleAnyHashTable </p>
**/
class IloMultipleAnyHashTable : public IloEnvHashTable<IloAny**, IloIntArrayI*> {
private:
	IloInt _size;
public:
	/** <p> . </p> */
	IloMultipleAnyHashTable(IloEnv env, IloInt size);
	virtual ~IloMultipleAnyHashTable();
};

/**
* @group optim.concert.tuple
* @show internal
* <p> IloNaryAnyCacheI </p>
**/
class IloNaryAnyCacheI : public IloTupleRequestCacheI {
private:
	IloInt _keySize;
	IloAny** _key;
	IloMultipleAnyHashTable* _hash;
public:
	/** <p> . </p> */
	IloNaryAnyCacheI(IloEnv env, 
		IloInt keySize, 
		IloAny** key,
		IloMultipleAnyHashTable* h);
	virtual ~IloNaryAnyCacheI();
	/** <p> . </p> */
	virtual IloIntArrayI* execute();
	/** <p> . </p> */
	virtual IloBool store(IloIntArrayI* slice);
};

class IloMultipleUnaryAnyHashTable : public IloEnvHashTable<IloAny**, IloInt> {
private:
	IloInt _size;
public:
	/** <p> . </p> */
	IloMultipleUnaryAnyHashTable(IloEnv env, IloInt size);
	virtual ~IloMultipleUnaryAnyHashTable();
};

class IloNaryAnyUnaryCacheI : public IloTupleRequestUnaryCacheI {
private:
	IloInt _keySize;
	IloAny** _key;
	IloMultipleUnaryAnyHashTable* _hash;
public:
	IloNaryAnyUnaryCacheI(IloEnv env, 
		IloInt keySize, 
		IloAny** key,
		IloMultipleUnaryAnyHashTable* h);
	virtual ~IloNaryAnyUnaryCacheI();
	virtual IloInt execute();
	virtual IloBool store(IloInt slice);
};


/**
* @group optim.concert.tuple
* @show internal
* <p> IloNaryCellCacheI </p>
**/
class IloNaryCellCacheI : public IloTupleRequestCacheI {
private:
	IloTupleRequestI* _key;
	IloTupleCellArray _keys;
	IloQueryDataTableHash* _hash;
public:
	/** <p> . </p> */
	IloNaryCellCacheI(IloEnv env, 
		IloTupleRequestI* key, 
		IloQueryDataTableHash* h);
	virtual ~IloNaryCellCacheI();
	/** <p> . </p> */
	virtual IloIntArrayI* execute();
	/** <p> . </p> */
	virtual IloBool store(IloIntArrayI* slice);
	IloTupleCellArray getOrMakeKeys();
	IloTupleCellArray makeKeys();
};

class IloQueryUnaryDataTableHash : public IloEnvHashTable<IloTupleCellArrayI*, IloInt>{
public:
	IloQueryUnaryDataTableHash(IloEnv env,IloInt size=IloDefaultHashSize);
		~IloQueryUnaryDataTableHash(){	
			for (IloQueryUnaryDataTableHash::Iterator it(this); it.ok(); ++it){
				IloTupleCellArray(it.getKey()).end();
			}
		}
};

class IloNaryCellUnaryCacheI : public IloTupleRequestUnaryCacheI {
private:
	IloTupleRequestI* _key;
	IloTupleCellArray _keys;
	IloQueryUnaryDataTableHash* _hash;
public:
	/** <p> . </p> */
	IloNaryCellUnaryCacheI(IloEnv env, 
		IloTupleRequestI* key, 
		IloQueryUnaryDataTableHash* h);
	virtual ~IloNaryCellUnaryCacheI();
	/** <p> . </p> */
	virtual IloInt execute();
	/** <p> . </p> */
	virtual IloBool store(IloInt slice);
	IloTupleCellArray getOrMakeKeys();
	IloTupleCellArray makeKeys();
};

#endif

