// ----------------------------------------------------------*- C++ -*-------
//  Copyright (C) 1990-2007 by ILOG.
//  All Rights Reserved.
//
//  N O T I C E
//
//  THIS MATERIAL IS CONSIDERED A TRADE SECRET BY ILOG.
//  UNAUTHORIZED ACCESS, USE, REPRODUCTION OR DISTRIBUTION IS PROHIBITED.
// --------------------------------------------------------------------------

#ifndef __XML_iloxmlexprpiecewiselinearH
#define __XML_iloxmlexprpiecewiselinearH



#if !defined(__XML_iloxmlabstractH)
#include <ilconcert/iloxmlabstract.h>
#endif

class IloExprPiecewiseLinearI;

/**
 * @show internal
 * @group optim.concert.xmlconcert
 *
 * <p>An instance of <code>IloXmlInfo_ExprPieceWiseLinear</code> 
 * makes it possible to serialize an
 * IloExprPiecewiseLinearI in XML. </p>
 * @see IloXmlContextI
 * @see IloXmlInfo
 * @see IloXmlReader
 * @see IloXmlWriter
 **/

class IloXmlInfo_ExprPieceWiseLinear : public IloXmlInfo {
	
public:
  static const char* getTagName();

  virtual const char* getTag() { return IloXmlInfo_ExprPieceWiseLinear::getTagName(); }
  IloXmlInfo_ExprPieceWiseLinear(IloXmlContextI* context);
  virtual IloBool write(IloXmlWriter writer, IloExprPiecewiseLinearI* exprI, IloXmlElement* masterElement);
  virtual IloBool write(IloXmlWriter writer, const IloRtti* extractableI, IloXmlElement* masterElement){
    return write(writer, (IloExprPiecewiseLinearI*)extractableI, masterElement);
  }
  virtual IloRtti* read(IloXmlReader reader, IloXmlElement* element);
};


#endif
