// ----------------------------------------------------------*- C++ -*-------
//  Copyright (C) 1990-2007 by ILOG.
//  All Rights Reserved.
//
//  N O T I C E
//
//  THIS MATERIAL IS CONSIDERED A TRADE SECRET BY ILOG.
//  UNAUTHORIZED ACCESS, USE, REPRODUCTION OR DISTRIBUTION IS PROHIBITED.
// --------------------------------------------------------------------------

#ifndef __XML_iloxmlmemberH
#define __XML_iloxmlmemberH



#if !defined(__XML_iloxmlabstractH)
#include <ilconcert/iloxmlabstract.h>
#endif


class IloIntMemberI;
class IloIntNotMemberI;

/**
 * @show internal
 * @group optim.concert.xmlconcert
 *
 * <p>An instance of <code>IloXmlInfo_IntMember</code> 
 * makes it possible to serialize an IloIntMemberI in XML. </p>
 * @see IloXmlContextI
 * @see IloXmlInfo
 * @see IloXmlReader
 * @see IloXmlWriter
 */

class IloXmlInfo_IntMember : public IloXmlInfo {
	
public:
  static const char* getTagName();

  virtual const char* getTag() { return IloXmlInfo_IntMember::getTagName(); }
  IloXmlInfo_IntMember(IloXmlContextI* context);
  virtual IloBool write(IloXmlWriter writer, IloIntMemberI* exprI, IloXmlElement* masterElement);
  virtual IloBool write(IloXmlWriter writer, const IloRtti* extractableI, IloXmlElement* masterElement){
    return write(writer, (IloIntMemberI*)extractableI, masterElement);
  }
  virtual IloRtti* read(IloXmlReader reader, IloXmlElement* element);

  virtual IloXmlElement* getTagElement(IloXmlWriter writer, const IloRtti* exprI){
    return getTagElement(writer, (IloIntMemberI*)exprI);
  }
  virtual IloXmlElement* getTagElement(IloXmlWriter writer, const IloIntMemberI* exprI);

};

/**
 * @show internal
 * @group optim.concert.xmlconcert
 *
 * <p>An instance of <code>IloXmlInfo_IntNotMember</code> 
 * makes it possible to serialize an IloIntNotMemberI in XML. </p>
 * @see IloXmlContextI
 * @see IloXmlInfo
 * @see IloXmlReader
 * @see IloXmlWriter
 */

class IloXmlInfo_IntNotMember : public IloXmlInfo {
	
public:
  static const char* getTagName();

  virtual const char* getTag() { return IloXmlInfo_IntNotMember::getTagName(); }
  IloXmlInfo_IntNotMember(IloXmlContextI* context);
  virtual IloBool write(IloXmlWriter writer, IloIntNotMemberI* exprI, IloXmlElement* masterElement);
  virtual IloBool write(IloXmlWriter writer, const IloRtti* extractableI, IloXmlElement* masterElement){
    return write(writer, (IloIntNotMemberI*)extractableI, masterElement);
  }
  virtual IloRtti* read(IloXmlReader reader, IloXmlElement* element);
  virtual IloXmlElement* getTagElement(IloXmlWriter writer, const IloRtti* exprI){
    return getTagElement(writer, (IloIntNotMemberI*)exprI);
  }
  virtual IloXmlElement* getTagElement(IloXmlWriter writer, const IloIntNotMemberI* exprI);


};

#endif
