// ----------------------------------------------------------*- C++ -*-------
//  Copyright (C) 1990-2007 by ILOG.
//  All Rights Reserved.
//
//  N O T I C E
//
//  THIS MATERIAL IS CONSIDERED A TRADE SECRET BY ILOG.
//  UNAUTHORIZED ACCESS, USE, REPRODUCTION OR DISTRIBUTION IS PROHIBITED.
// --------------------------------------------------------------------------



#ifndef __XML_iloxmloperatorH
#define __XML_iloxmloperatorH


#if !defined(__XML_iloxmlabstractH)
#include <ilconcert/iloxmlabstract.h>
#endif





// ----------------------------------------------------------*- C++ -*-------
// ----------------------------------------------------------*- C++ -*-------
//
//    INCLUDE CODE FOR A NEW ILOCONSTRAINT
//
// ----------------------------------------------------------*- C++ -*-------
// ----------------------------------------------------------*- C++ -*-------


// ----------------------------------------------------------*- C++ -*-------
//    INCLUDE FOR IloXmlNumEq
// ----------------------------------------------------------*- C++ -*-------


class IloNumEqI;


/**
 * @show internal
 * @group optim.concert.xmlconcert
 *
 * <p>An instance of IloXmlInfo_NumEq 
 * makes it possible to serialize an IloNumEqI in XML. </p>
 * @see IloXmlContextI
 * @see IloXmlInfo
 * @see IloXmlReader
 * @see IloXmlWriter
 */
class IloXmlInfo_NumEq : public IloXmlInfo {
	
public:
  static const char* getTagName();
  virtual const char* getTag() {
    return IloXmlInfo_NumEq::getTagName();
  }
  IloXmlInfo_NumEq(IloXmlContextI* context);

  virtual IloBool write(IloXmlWriter writer, IloNumEqI* exprI, IloXmlElement* masterElement);
  virtual IloBool write(IloXmlWriter writer, const IloRtti* extractableI, IloXmlElement* masterElement){
    return write(writer, (IloNumEqI*)extractableI, masterElement);
  }
  virtual IloRtti* read(IloXmlReader reader, IloXmlElement* element);
};





// ----------------------------------------------------------*- C++ -*-------
// ----------------------------------------------------------*- C++ -*-------
//
//    INCLUDE CODE FOR A NEW ILOCONSTRAINT
//
// ----------------------------------------------------------*- C++ -*-------
// ----------------------------------------------------------*- C++ -*-------


// ----------------------------------------------------------*- C++ -*-------
//    INCLUDE FOR IloXmlNumGe
// ----------------------------------------------------------*- C++ -*-------


class IloNumGeI;


/**
 * @show internal
 * @group optim.concert.xmlconcert
 *
 * <p>An instance of IloXmlInfo_NumGe 
 * makes it possible to serialize an IloNumGeI in XML. </p>
 * @see IloXmlContextI
 * @see IloXmlInfo
 * @see IloXmlReader
 * @see IloXmlWriter
 */
class IloXmlInfo_NumGe : public IloXmlInfo {
	
public:
  static const char* getTagName();
  virtual const char* getTag() {
    return IloXmlInfo_NumGe::getTagName();
  }
  IloXmlInfo_NumGe(IloXmlContextI* context);

  virtual IloBool write(IloXmlWriter writer, IloNumGeI* exprI, IloXmlElement* masterElement);
  virtual IloBool write(IloXmlWriter writer, const IloRtti* extractableI, IloXmlElement* masterElement){
    return write(writer, (IloNumGeI*)extractableI, masterElement);
  }
  virtual IloRtti* read(IloXmlReader reader, IloXmlElement* element);
};





// ----------------------------------------------------------*- C++ -*-------
// ----------------------------------------------------------*- C++ -*-------
//
//    INCLUDE CODE FOR A NEW ILOCONSTRAINT
//
// ----------------------------------------------------------*- C++ -*-------
// ----------------------------------------------------------*- C++ -*-------


// ----------------------------------------------------------*- C++ -*-------
//    INCLUDE FOR IloXmlNumLe
// ----------------------------------------------------------*- C++ -*-------


class IloNumLeI;


/**
 * @show internal
 * @group optim.concert.xmlconcert
 *
 * <p>An instance of IloXmlInfo_NumLe 
 * makes it possible to serialize an IloNumLeI in XML. </p>
 * @see IloXmlContextI
 * @see IloXmlInfo
 * @see IloXmlReader
 * @see IloXmlWriter
 */
class IloXmlInfo_NumLe : public IloXmlInfo {
	
public:
  static const char* getTagName();
  virtual const char* getTag() {
    return IloXmlInfo_NumLe::getTagName();
  }
  IloXmlInfo_NumLe(IloXmlContextI* context);

  virtual IloBool write(IloXmlWriter writer, IloNumLeI* exprI, IloXmlElement* masterElement);
  virtual IloBool write(IloXmlWriter writer, const IloRtti* extractableI, IloXmlElement* masterElement){
    return write(writer, (IloNumLeI*)extractableI, masterElement);
  }
  virtual IloRtti* read(IloXmlReader reader, IloXmlElement* element);
};





// ----------------------------------------------------------*- C++ -*-------
// ----------------------------------------------------------*- C++ -*-------
//
//    INCLUDE CODE FOR A NEW ILOCONSTRAINT
//
// ----------------------------------------------------------*- C++ -*-------
// ----------------------------------------------------------*- C++ -*-------


// ----------------------------------------------------------*- C++ -*-------
//    INCLUDE FOR IloXmlNumGT
// ----------------------------------------------------------*- C++ -*-------


class IloNumGTI;


/**
 * @show internal
 * @group optim.concert.xmlconcert
 *
 * <p>An instance of IloXmlInfo_NumGT 
 * makes it possible to serialize an IloNumGTI in XML. </p>
 * @see IloXmlContextI
 * @see IloXmlInfo
 * @see IloXmlReader
 * @see IloXmlWriter
 */
class IloXmlInfo_NumGT : public IloXmlInfo {
	
public:
  static const char* getTagName();
  virtual const char* getTag() {
    return IloXmlInfo_NumGT::getTagName();
  }
  IloXmlInfo_NumGT(IloXmlContextI* context);

  virtual IloBool write(IloXmlWriter writer, IloNumGTI* exprI, IloXmlElement* masterElement);
  virtual IloBool write(IloXmlWriter writer, const IloRtti* extractableI, IloXmlElement* masterElement){
    return write(writer, (IloNumGTI*)extractableI, masterElement);
  }
  virtual IloRtti* read(IloXmlReader reader, IloXmlElement* element);
};





// ----------------------------------------------------------*- C++ -*-------
// ----------------------------------------------------------*- C++ -*-------
//
//    INCLUDE CODE FOR A NEW ILOCONSTRAINT
//
// ----------------------------------------------------------*- C++ -*-------
// ----------------------------------------------------------*- C++ -*-------


// ----------------------------------------------------------*- C++ -*-------
//    INCLUDE FOR IloXmlNumLT
// ----------------------------------------------------------*- C++ -*-------


class IloNumLTI;


/**
 * @show internal
 * @group optim.concert.xmlconcert
 *
 * <p>An instance of IloXmlInfo_NumLT 
 * makes it possible to serialize an IloNumLTI in XML. </p>
 * @see IloXmlContextI
 * @see IloXmlInfo
 * @see IloXmlReader
 * @see IloXmlWriter
 */
class IloXmlInfo_NumLT : public IloXmlInfo {
	
public:
  static const char* getTagName();
  virtual const char* getTag() {
    return IloXmlInfo_NumLT::getTagName();
  }
  IloXmlInfo_NumLT(IloXmlContextI* context);

  virtual IloBool write(IloXmlWriter writer, IloNumLTI* exprI, IloXmlElement* masterElement);
  virtual IloBool write(IloXmlWriter writer, const IloRtti* extractableI, IloXmlElement* masterElement){
    return write(writer, (IloNumLTI*)extractableI, masterElement);
  }
  virtual IloRtti* read(IloXmlReader reader, IloXmlElement* element);
};


#endif
